﻿using Hotline.FlowEngine.Definitions;
using Hotline.Share.Dtos.FlowEngine;

namespace Hotline.FlowEngine.Workflows
{
    public interface IWorkflowDomainService
    {
        ///// <summary>
        ///// 获取当前节点（针对某操作人的当前节点）
        ///// </summary>
        ///// <returns></returns>
        //Task<(StepBox, Step)> GetStepAsync(string workflowId, string depCode, string userId, CancellationToken cancellationToken);
        //(StepBox, Step) GetStep(List<StepBox> stepBoxes, string depCode, string userId);

        /// <summary>
        /// 获取可能前往的下一节点
        /// </summary>
        /// <returns></returns>
        Task<IReadOnlyList<NextStepDefine>> GetNextStepsAsync(QueryWorkflowDto dto, CancellationToken cancellationToken);
        

        ///////////

        Task<Workflow> CreateWorkflowAsync(Definition definition, CancellationToken cancellationToken);

        /// <summary>
        /// 进行流程的开始节点
        /// </summary>
        Task StartAsync(Workflow workflow, BasicWorkflowDto dto, CancellationToken cancellationToken);

        Task<Workflow> GetWorkflowAsync(string workflowId, CancellationToken cancellationToken);

        /// <summary>
        /// 受理,接办
        /// </summary>
        Task AcceptAsync(Workflow workflow, CancellationToken cancellationToken);

        /// <summary>
        /// 办理（流转至下一节点）
        /// </summary>
        Task NextAsync(Workflow workflow, BasicWorkflowDto dto, StepDefine nextStepBoxDefine, bool isOutOfCallCenter, CancellationToken cancellationToken);

        /// <summary>
        /// 退回（返回前一节点）
        /// </summary>
        /// <returns></returns>
        Task PreviousAsync(Workflow workflow, PreviousWorkflowDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 撤回（返回到之前任意节点）
        /// </summary>
        Task RecallAsync(Workflow workflow, RecallDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 跳转（直接将流程跳转至任意节点）
        /// </summary>
        Task JumpAsync(Workflow workflow, RecallDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 补充
        /// </summary>
        /// <returns></returns>
        Task SupplementAsync(Workflow workflow, EndWorkflowDto dto, CancellationToken cancellationToken);

        StepDefine GetStepBoxDefine(Definition definition, string stepCode);
    }
}
